# -*- coding: utf-8 -*-

#	Copyright (c) Alexander Sedov 2008

#	This file is part of Nodes.
#	
#	Nodes is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	Nodes is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with Nodes.  If not, see <http://www.gnu.org/licenses/>.

from distutils.core import setup, Extension
import sys, os
if os.path.exists(os.path.join(os.path.dirname(sys.argv[0]), 'cnodes.c')):
	file='cnodes.c'
	cmdclass={}
else:
	from Pyrex.Distutils import build_ext
	file='cnodes.pyx'
	cmdclass={
	'build_ext':build_ext
	}
setup(
	name='nodes',
	version='0.1',
	author='Alexander Sedov -- Electronic from .RU (Lomy.RU)',
	author_email='Elec.Lomy.RU@gmail.com',
	description='Automatic Intellect implementation',
	classifiers=[
		'Development Status :: 1 - Planning',
		'License :: OSI Approved :: GNU General Public License',
		'Intended Audience :: Developers',
		'Operating System :: Any',
		'Platform :: Any',
		'Programming Language :: Python',
		'Topic :: AI',
		'Topic :: Software Development'
		],
	py_modules=['core', 'varios', 'basic', 'logic', 'construct', 'inspector', 'expectations'],
	ext_modules=[Extension('cnodes', [file])],
	cmdclass=cmdclass
	)
