#	Copyright (c) Alexander Sedov 2008

#	This file is part of Nodes.
#	
#	Nodes is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	Nodes is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with Nodes.  If not, see <http://www.gnu.org/licenses/>.

"""Randomization functions."""
from core import Synaps, InputSynaps, OutputSynaps #отсюда
import random

#Variositied touching
class VariositiedSynaps(Synaps):
	def __init__(self, variosity):
		assert variosity<=1
		self.variosity=variosity

	def __getattribute__(self, attr):
		if self.__dict__.has_key(attr):
			if self.dict.has_key('null_'+attr):
				if random.random()>self.variosity: #ok-cancel. Using >= is non-sense.
					attr='null_'+attr
			return super(Synaps, self).__getattribute__(attr)
		else:
			raise AttributeError

class VariositiedInputSynaps(VariositiedSynaps, InputSynaps):
	def __init__(self, node, index, variosity):
		VariositiedSynaps.__init__(self, variosity)
		InputSynaps.__init__(self, node, index)

	def null_get(self):
		return None #correctly handled by Nodes.

		def null_back_propagate(self, value):
				pass

class VariositiedOutputSynaps(VariositiedSynaps, OutputSynaps):
	def __init__(self, node, index, variosity):
		VariositiedSynaps.__init__(self, variosity)
		OutputSynaps.__init__(self, node, index)

	def null_put(self, value):
		self.retry=value

#Variositied creation (!)
class NullInputSynaps(InputSynaps):
	def __init__(self, node, index):
		Synaps.__init__(self, node, index) #Dummy for introspecting.

	def get(self):
		return None
class NullOutputSynaps(OutputSynaps):
	def __init__(self, node, index):
		Synaps.__init__(self, node, index)

	def put(self, value):
		pass

def RandomInputSynaps(node, index, variosity):
	class_=InputSynaps
	if random.random()>variosity:
		class_=NullInputSynaps
	return class_(node, index)

def RandomOutputSynaps(node, index, variosity):
	class_=OutputSynaps
	if random.random()>variosity:
		class_=NullOutputSynaps
	return class_(node, index)
